#ifndef __RENDERER_H__
#define __RENDERER_H__

#include <avr/pgmspace.h>
#include "tetrominoes.h"
#include "game.h"

/**
 * Function to initialise the internal functionality of the render unit.
 * @param board vectorised matrix with all minoes from the board
 * @param height height of the board
 * @param width width of the board
 * @param tetro pointer to the falling tetromino
 */
void renderer_init(void);

/**
 * Draw all elements from the scene, minoes, falling tetromino and text.
 */
void render_scene(void);

#endif /* __RENDERER_H__ */
