#include "tetrominoes.h"


// Data of all tetrominoes
static const uint8_t i_data[4*4*4] = {
  
  0, 0, 0, 0,
  0, 0, 0, 0,
  1, 1, 1, 1,
  0, 0, 0, 0,

  0, 0, 1, 0,
  0, 0, 1, 0,
  0, 0, 1, 0,
  0, 0, 1, 0,

  0, 0, 0, 0,
  1, 1, 1, 1,
  0, 0, 0, 0,
  0, 0, 0, 0,

  0, 1, 0, 0,
  0, 1, 0, 0,
  0, 1, 0, 0,
  0, 1, 0, 0
};

static const uint8_t j_data[4*3*3] = {
  
  0, 0, 0,
  1, 1, 1,
  1, 0, 0,

  0, 1, 0,
  0, 1, 0,
  0, 1, 1,

  0, 0, 1,
  1, 1, 1,
  0, 0, 0,

  1, 1, 0,
  0, 1, 0,
  0, 1, 0
};

static const uint8_t l_data[4*3*3] = {

  0, 0, 0,
  1, 1, 1,
  0, 0, 1,

  0, 1, 1,
  0, 1, 0,
  0, 1, 0,

  1, 0, 0,
  1, 1, 1,
  0, 0, 0,

  0, 1, 0,
  0, 1, 0,
  1, 1, 0
};

static const uint8_t o_data[1*4*4] = {

  0, 0, 0, 0,
  0, 1, 1, 0,
  0, 1, 1, 0,
  0, 0, 0, 0
};

static const uint8_t s_data[4*3*3] = {

  0, 0, 0,
  1, 1, 0,
  0, 1, 1,

  0, 0, 1,
  0, 1, 1,
  0, 1, 0,

  1, 1, 0,
  0, 1, 1,
  0, 0, 0,
  
  0, 1, 0,
  1, 1, 0,
  1, 0, 0
};

static const uint8_t t_data[4*3*3] = {

  0, 0, 0,
  1, 1, 1,
  0, 1, 0,

  0, 1, 0,
  0, 1, 1,
  0, 1, 0,

  0, 1, 0,
  1, 1, 1,
  0, 0, 0,

  0, 1, 0,
  1, 1, 0,
  0, 1, 0,
};

static const uint8_t z_data[4*3*3] = {
  
  0, 0, 0,
  0, 1, 1,
  1, 1, 0,
  
  0, 1, 0,
  0, 1, 1,
  0, 0, 1,
  
  0, 1, 1,
  1, 1, 0,
  0, 0, 0,
 
  1, 0, 0,
  1, 1, 0,
  0, 1, 0
};


const struct tetro tetro_i = {
	.type = T_I,
	.data = i_data,

	.size = 4,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_j = {
	.type = T_J,
	.data = j_data,

	.size = 3,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_l = {
	.type = T_L,
	.data = l_data,

	.size = 3,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_o = {
	.type = T_O,
	.data = o_data,

	.size = 4,
	.rot = 0,
	.max_rot = 1,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_s = {
	.type = T_S,
	.data = s_data,

	.size = 3,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_t = {
	.type = T_T,
	.data = t_data,

	.size = 3,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_z = {
	.type = T_Z,
	.data = z_data,

	.size = 3,
	.rot = 0,
	.max_rot = 4,

	.row = 0,
	.col = 0,
};

const struct tetro tetro_none = {
	.type = T_NONE,
	.data = 0,

	.size = 0,
	.rot = 0,
	.max_rot = 0,

	.row = 0,
	.col = 0,
};

uint8_t tetro_get_data(struct tetro *tetro, int row, int col, uint8_t rot)
{
	return tetro->data[rot * tetro->size * tetro->size + row * tetro->size + col];
}
